///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "MobFlameObj.h"
#include "MobFormat.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

///////////////////////////////////
//TFlameObjBlock
///////////////////////////////////

DWORD TFlameObjBlock::GetBlockSize()
//       .
{
  //...
  DWORD Result = 40;
  int i;
  //44 -    .

  //   ,      ...
  Result = Result + SoundStr.Length();

  //       
  //  ...
  Result = Result + TObjectObjBlock::GetBlockSize();

  return Result;
};

bool TFlameObjBlock::ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj)
//     .
{
  // ...
  DWORD TempDW1, MinBlockSgn, MinBlockSize, TempDW2, i;
  bool Result = true;
  __int64 Cursor = 8;

  //    .
  do
  {
    //  ...
    memcpy(&MinBlockSgn,&Buff[Cursor],4);
    Cursor = Cursor+4;
    //     ...
    if (MinBlockSgn == Flm_Sgn_Coords)
    {
      // 
      //float X 3

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&CoordX,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&CoordY,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&CoordZ,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }


    else if (MinBlockSgn == Flm_Sgn_FlameSize)
    {
      //  
      //float

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&FlameSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Flm_Sgn_SoundStr)
    {
      //     
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      SoundStr.SetLength(MinBlockSize-8);

      if ((MinBlockSize-8) != 0)
      {
        // ...
        memcpy(&SoundStr[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        SoundStr = "";
      };
    }

    else if (MinBlockSgn == Obj_Sgn_BodyTextures)  //       ...
    {
      //  -       ...
      MinBlockSize = GetNMobBlocksSize(Buff,Cursor-4,17);  //    
      TObjectObjBlock::ReadBlock(&Buff[Cursor-12],MinBlockSize+8,UseLog,PMobObj);
      Cursor = Cursor+MinBlockSize-4;  //   . ...
    };

  }
  while (Cursor != BuffSize);

  StopLoadUnitBlock:        //     .
  ;
  return Result;
};

byte* TFlameObjBlock::GenBlock(DWORD& BlockSize)
// ...
{
  //
  byte* Result = NULL;
  int i = 0; //
  DWORD ChetireBaita, BlockSignature;
  DWORD Cursor = 0;

  //, .      ...
  BlockSize = GetBlockSize();
  Result = new byte[BlockSize];

  // ...
  memcpy(&Result[Cursor],&OB_Sgn_Flame,4);
  Cursor = Cursor+4;

  // .
  memcpy(&Result[Cursor],&BlockSize,4);
  Cursor = Cursor+4;
  
  // 
  //float X 3
  // 
  memcpy(&Result[Cursor],&Flm_Sgn_Coords,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 20;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&CoordX,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&CoordY,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&CoordZ,4);
  Cursor = Cursor+4;

  //  
  //float
  // 
  memcpy(&Result[Cursor],&Flm_Sgn_FlameSize,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&FlameSize,4);
  Cursor = Cursor+4;

  //     
  //String
  // 
  memcpy(&Result[Cursor],&Flm_Sgn_SoundStr,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+SoundStr.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&SoundStr[1],SoundStr.Length());
    Cursor = Cursor+SoundStr.Length();
  };

  //    ...
  TObjectObjBlock::GenBasePart(&Result[Cursor]);
  Cursor = Cursor+TObjectObjBlock::GetBlockSize()-8;

  //  ...
  return Result;
};
