///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "MobParticle1Obj.h"
#include "MobFormat.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

///////////////////////////////////
//TParticle1ObjBlock
///////////////////////////////////

DWORD TParticle1ObjBlock::GetBlockSize()
//       .
{
  //...
  DWORD Result = 89;
  int i;
  //89 -       .

  //   ...
  Result = Result + NameStr.Length() + UnknStr1.Length();

  //         -
  //       - 8 .
  Result = Result + 8;

  return Result;
};

bool TParticle1ObjBlock::ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj)
//     .
{
  // ...
  DWORD TempDW1, MinBlockSgn, MinBlockSize, TempDW2, i;
  bool Result = true;
  __int64 Cursor = 8;

  //    .
  do
  {
    //  ...
    memcpy(&MinBlockSgn,&Buff[Cursor],4);
    Cursor = Cursor+4;
    //     ...
    if (MinBlockSgn == Ptl1_Sgn_ID)
    {
      //   ...
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&ID,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl1_Sgn_UnknByte1)
    {
      // byte1
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UnknByte1,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Ptl1_Sgn_Coords)
    {
      //
      //float X 3

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&CoordX,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&CoordY,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&CoordZ,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl1_Sgn_Color)
    {
      //  RGB
      //float X 3

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&ColorR,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&ColorG,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&ColorB,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl1_Sgn_ParticleSize)
    {
      //   
      //float

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&ParticleSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Ptl1_Sgn_NameStr)
    {
      //  
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      NameStr.SetLength(MinBlockSize-8);

      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&NameStr[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        NameStr = "";
      };
    }

    else if (MinBlockSgn == Ptl1_Sgn_UnknStr1)
    {
      //  
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      UnknStr1.SetLength(MinBlockSize-8);

      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&UnknStr1[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        UnknStr1 = "";
      };
    };

  }
  while (Cursor != BuffSize);

  StopLoadUnitBlock:        //     .
  ;
  return Result;
};

byte* TParticle1ObjBlock::GenBlock(DWORD& BlockSize)
// ...
{
  //
  byte* Result = NULL;
  int i = 0; //
  DWORD ChetireBaita, BlockSignature;
  DWORD Cursor = 0;

  //, .      ...
  BlockSize = GetBlockSize();
  Result = new byte[BlockSize];

  // ...
  memcpy(&Result[Cursor],&OB_Sgn_Particle1,4);
  Cursor = Cursor+4;

  // .
  memcpy(&Result[Cursor],&BlockSize,4);
  Cursor = Cursor+4;

  //   ...
  //DWORD
  // 
  memcpy(&Result[Cursor],&Ptl1_Sgn_ID,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&ID,4);
  Cursor = Cursor+4;

  // byte1
  //byte
  // 
  memcpy(&Result[Cursor],&Ptl1_Sgn_UnknByte1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UnknByte1,1);
  Cursor = Cursor+1;

  //
  //float X 3
  // 
  memcpy(&Result[Cursor],&Ptl1_Sgn_Coords,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 20;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&CoordX,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&CoordY,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&CoordZ,4);
  Cursor = Cursor+4;

  //  RGB
  //float X 3
  // 
  memcpy(&Result[Cursor],&Ptl1_Sgn_Color,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 20;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&ColorR,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&ColorG,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&ColorB,4);
  Cursor = Cursor+4;

  //   
  //float
  // 
  memcpy(&Result[Cursor],&Ptl1_Sgn_ParticleSize,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&ParticleSize,4);
  Cursor = Cursor+4;

  //  
  //String
  // 
  memcpy(&Result[Cursor],&Ptl1_Sgn_NameStr,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+NameStr.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&NameStr[1],NameStr.Length());
    Cursor = Cursor+NameStr.Length();
  };

  //  
  //String
  // 
  memcpy(&Result[Cursor],&Ptl1_Sgn_UnknStr1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+UnknStr1.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&UnknStr1[1],UnknStr1.Length());
    Cursor = Cursor+UnknStr1.Length();
  };

  //  ...
  return Result;
};
