///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "MobUnitObj.h"
#include "MobFormat.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

///////////////////////////////////
//TUnitObjBlock
///////////////////////////////////

TUnitObjBlock::TUnitObjBlock()
{
  BehaviourDatas = NULL;
};

DWORD TUnitObjBlock::GetBlockSize()
//       .
{
  //...
  DWORD Result = 77;
  int i;
  //77 -    .

  //...
  //   ...
  Result = Result + Name1.Length() + TableDataSize/* + BehaviourDataSize*/;

  //  ...
  //Result = Result + 12;  //12 -   ,  .
  for (i = 0; i < Armour->Length; i++)
  {
    Result = Result + Armour->operator[](i).Length() + 8;
  };

  //Result = Result + 12;
  for (i = 0; i < Weapon->Length; i++)
  {
    Result = Result + Weapon->operator[](i).Length() + 8;
  };

  //Result = Result + 12;
  for (i = 0; i < Spell->Length; i++)
  {
    Result = Result + Spell->operator[](i).Length() + 8;
  };

  //Result = Result + 12;
  for (i = 0; i < Items->Length; i++)
  {
    Result = Result + Items->operator[](i).Length() + 8;
  };

  for (i = 0; i < BehaviourDatas->Length; i++)
  {
    Result = Result + BehaviourDatas->operator[](i).BehaviourDataSize;
  };

  //       
  //  ...
  Result = Result + TObjectObjBlock::GetBlockSize();

  return Result;
};

bool TUnitObjBlock::ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj)
//     .
{
  // ...
  DWORD TempDW1, MinBlockSgn, MinBlockSize, TempDW2, i;
  bool Result = true;
  __int64 Cursor = 8;

  //    .
  do
  {
    //  ...
    memcpy(&MinBlockSgn,&Buff[Cursor],4);
    Cursor = Cursor+4;
    //     ...
    if (MinBlockSgn == U_Sgn_UseMobInfo)
    {
      //,      -     .
      //byte

      Cursor = Cursor+4;  //   -  .
      // ...
      memcpy(&UseMobInfo,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }


    else if (MinBlockSgn == U_Sgn_Name1)
    {
      // .
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      Name1.SetLength(MinBlockSize-8);

      if ((MinBlockSize-8) != 0)
      {
        // ...
        memcpy(&Name1[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        Name1 = "";
      };

    }


    else if (MinBlockSgn == U_Sgn_Armour)
    {
      //.
      //DynamicArray <String>

      //   .
      Armour = new DynamicArray <String>;

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  
      memcpy(&TempDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (TempDW1 != 0)
      {
        //  ...
        // ...
        Armour->Length = TempDW1;

        i = -1;
        do
        {
          //   ...
          TempDW1 = TempDW1-1; //  -        
          i = i+1;

          Cursor = Cursor+4;  // 

          //  ...
          memcpy(&TempDW2,&Buff[Cursor],4);
          Cursor = Cursor+4;

          // ...
          if ((TempDW2 - 8) != 0)
          {
            Armour->operator[](i).SetLength((TempDW2 - 8));
            memcpy(&Armour->operator[](i)[1],&Buff[Cursor],(TempDW2 - 8));
            Cursor = Cursor+(TempDW2 - 8);
          }
          else
          {
            Armour->operator[](i) = "";
          };
        }
        while (TempDW1 != 0);
      }
      else
      {
        //  ...
        Armour->Length = 0;
      };
    }

    else if (MinBlockSgn == U_Sgn_Weapon)
    {
      //.
      //DynamicArray <String>

      //   .
      Weapon = new DynamicArray <String>;

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  
      memcpy(&TempDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (TempDW1 != 0)
      {
        //  ...
        // ...
        Weapon->Length = TempDW1;
        i = -1;
        do
        {
          //   ...
          TempDW1 = TempDW1-1; //  -        
          i = i+1;

          Cursor = Cursor+4;  // 

          //  ...
          memcpy(&TempDW2,&Buff[Cursor],4);
          Cursor = Cursor+4;

          // ...
          if ((TempDW2 - 8) != 0)
          {
            Weapon->operator[](i).SetLength((TempDW2 - 8));
            memcpy(&Weapon->operator[](i)[1],&Buff[Cursor],(TempDW2 - 8));
            Cursor = Cursor+(TempDW2 - 8);
          }
          else
          {
            Weapon->operator[](i) = "";
          };
        }
        while (TempDW1 != 0);
      }
      else
      {
        //  ...
        Weapon->Length = 0;
      };
    }


    else if (MinBlockSgn == U_Sgn_Spell)
    {
      //.
      //DynamicArray <String>

      //   .
      Spell = new DynamicArray <String>;

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  
      memcpy(&TempDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (TempDW1 != 0)
      {
        //  ...
        // ...
        Spell->Length = TempDW1;
        i = -1;
        do
        {
          //   ...
          TempDW1 = TempDW1-1; //  -        
          i = i+1;

          Cursor = Cursor+4;  // 

          //  ...
          memcpy(&TempDW2,&Buff[Cursor],4);
          Cursor = Cursor+4;

          // ...
          if ((TempDW2 - 8) != 0)
          {
            Spell->operator[](i).SetLength((TempDW2 - 8));
            memcpy(&Spell->operator[](i)[1],&Buff[Cursor],(TempDW2 - 8));
            Cursor = Cursor+(TempDW2 - 8);
          }
          else
          {
            Spell->operator[](i) = "";
          };
        }
        while (TempDW1 != 0);
      }
      else
      {
        //  ...
        Spell->Length = 0;
      };
    }


    else if (MinBlockSgn == U_Sgn_UncnDw1)
    {
      // dw.
      //DWORD

       //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (MinBlockSize == 12)
      {
        //   DWORD.

        //  ...
        memcpy(&UncnDw1,&Buff[Cursor],4);
        Cursor = Cursor+4;
      }
      else
      {
        // !

        // .
        if (UseLog == true)
        {
          PMobObj->StringToLog(" 06 00 BB BB      "+IntToStr(PMobObj->UnitObjs.High+1)+"-    "+IntToStr(MinBlockSize)+" ,        12 .  ." );
          goto StopLoadUnitBlock;
        };
        Result = false;
      };
    }


    else if (MinBlockSgn == U_Sgn_Items)
    {
      //
      //DynamicArray <String>

      //   .
      Items = new DynamicArray <String>;

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  
      memcpy(&TempDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (TempDW1 != 0)
      {
        //  ...
        // ...
        Items->Length = TempDW1;
        i = -1;
        do
        {
          //   ...
          TempDW1 = TempDW1-1; //  -        
          i = i+1;


          Cursor = Cursor+4;  // 

          //  ...
          memcpy(&TempDW2,&Buff[Cursor],4);
          Cursor = Cursor+4;

          // ...
          if ((TempDW2 - 8) != 0)
          {
            Items->operator[](i).SetLength((TempDW2 - 8));
            memcpy(&Items->operator[](i)[1],&Buff[Cursor],(TempDW2 - 8));
            Cursor = Cursor+(TempDW2 - 8);
          }
          else
          {
            Items->operator[](i) = "";
          };
        }
        while (TempDW1 != 0);
      }
      else
      {
        //  ...
        Items->Length = 0;
      };
    }


    else if (MinBlockSgn == U_Sgn_TableData)
    {
      //" "
      //       .
      //byte *

      //  ...
      memcpy(&TableDataSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  .
      Cursor = Cursor-8;  //      .
      TableData = new byte[TableDataSize];
      memcpy(&TableData[0],&Buff[Cursor],TableDataSize);
      Cursor = Cursor+TableDataSize;
    }

    else if (MinBlockSgn == Obj_Sgn_BodyTextures)
    {
      //  -       ...
      //-      ....     :).
      MinBlockSize = GetNMobBlocksSize(Buff,Cursor-4,17);  //    
      TObjectObjBlock::ReadBlock(&Buff[Cursor-12],MinBlockSize+8,UseLog,PMobObj);
      Cursor = Cursor+MinBlockSize-4;  //   . ...
    }

    else if (MinBlockSgn == U_Sgn_BehaviourData)
    {
      // .
      //   .
      //DynamicArray <BehaviourDataBlock>

      if (BehaviourDatas == NULL)
      {
        //      -   :).
        BehaviourDatas = new DynamicArray <BehaviourDataBlock>;
        BehaviourDatas->Length = 0;  //   ...
      };

      // 1 ...
      BehaviourDatas->Length = BehaviourDatas->Length+1;



      //  ...
      memcpy(&BehaviourDatas->operator [](BehaviourDatas->Length-1).BehaviourDataSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  .
      Cursor = Cursor-8;  //      .
      BehaviourDatas->operator [](BehaviourDatas->Length-1).BehaviourData = new byte[BehaviourDatas->operator [](BehaviourDatas->Length-1).BehaviourDataSize];
      memcpy(&BehaviourDatas->operator [](BehaviourDatas->Length-1).BehaviourData[0],&Buff[Cursor],BehaviourDatas->operator [](BehaviourDatas->Length-1).BehaviourDataSize);
      Cursor = Cursor+BehaviourDatas->operator [](BehaviourDatas->Length-1).BehaviourDataSize;
    };


  }
  while (Cursor != BuffSize);

  StopLoadUnitBlock:        //     .
  ;
  return Result;
};

byte* TUnitObjBlock::GenBlock(DWORD& BlockSize)
// ...
{
  //
  byte* Result = NULL;
  int i = 0; //
  DWORD ChetireBaita, BlockSignature;
  DWORD Cursor = 0;

  //, .      ...
  BlockSize = GetBlockSize();
  Result = new byte[BlockSize];

  // ...
  memcpy(&Result[Cursor],&OB_Sgn_Unit,4);
  Cursor = Cursor+4;

  // .
  memcpy(&Result[Cursor],&BlockSize,4);
  Cursor = Cursor+4;

  //,      -     .
  //byte
  // 
  memcpy(&Result[Cursor],&U_Sgn_UseMobInfo,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UseMobInfo,1);
  Cursor = Cursor+1;

  // .
  //String
  // 
  memcpy(&Result[Cursor],&U_Sgn_Name1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+Name1.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&Name1[1],Name1.Length());
    Cursor = Cursor+Name1.Length();
  };  

  //.
  //DynamicArray <String>
  // 
  memcpy(&Result[Cursor],&U_Sgn_Armour,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 0;
  for (i = 0; i < Armour->Length; i++)
  {
    ChetireBaita = ChetireBaita + Armour->operator[](i).Length() + 8;
  };
  ChetireBaita = ChetireBaita + 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //   ...
  ChetireBaita = Armour->Length;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  // ...
  for (i = 0; i < Armour->Length; i++)
  {
    // 
    memcpy(&Result[Cursor],&U_Sgn_Armour,4);
    Cursor = Cursor+4;
    // ...
    ChetireBaita = 8+Armour->operator[](i).Length();
    memcpy(&Result[Cursor],&ChetireBaita,4);
    Cursor = Cursor+4;
    //...
    if (Armour->operator[](i).Length() > 0)
    {
      memcpy(&Result[Cursor],&Armour->operator[](i)[1],Armour->operator[](i).Length());
      Cursor = Cursor+Armour->operator[](i).Length();
    };  
  };

  //.
  //DynamicArray <String>
  // 
  memcpy(&Result[Cursor],&U_Sgn_Weapon,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 0;
  for (i = 0; i < Weapon->Length; i++)
  {
    ChetireBaita = ChetireBaita + Weapon->operator[](i).Length() + 8;
  };
  ChetireBaita = ChetireBaita + 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //   ...
  ChetireBaita = Weapon->Length;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  // ...
  for (i = 0; i < Weapon->Length; i++)
  {
    // 
    memcpy(&Result[Cursor],&U_Sgn_Weapon,4);
    Cursor = Cursor+4;
    // ...
    ChetireBaita = 8+Weapon->operator[](i).Length();
    memcpy(&Result[Cursor],&ChetireBaita,4);
    Cursor = Cursor+4;
    //...
    if (Weapon->operator[](i).Length() > 0)
    {
      memcpy(&Result[Cursor],&Weapon->operator[](i)[1],Weapon->operator[](i).Length());
      Cursor = Cursor+Weapon->operator[](i).Length();
    };  
  };

  //.
  //DynamicArray <String>
  // 
  memcpy(&Result[Cursor],&U_Sgn_Spell,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 0;
  for (i = 0; i < Spell->Length; i++)
  {
    ChetireBaita = ChetireBaita + Spell->operator[](i).Length() + 8;
  };
  ChetireBaita = ChetireBaita + 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //   ...
  ChetireBaita = Spell->Length;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  // ...
  for (i = 0; i < Spell->Length; i++)
  {
    // 
    memcpy(&Result[Cursor],&U_Sgn_Spell,4);
    Cursor = Cursor+4;
    // ...
    ChetireBaita = 8+Spell->operator[](i).Length();
    memcpy(&Result[Cursor],&ChetireBaita,4);
    Cursor = Cursor+4;
    //...
    if (Spell->operator[](i).Length() > 0)
    {
      memcpy(&Result[Cursor],&Spell->operator[](i)[1],Spell->operator[](i).Length());
      Cursor = Cursor+Spell->operator[](i).Length();
    };
  };
  
  // dw.
  //DWORD
  // 
  memcpy(&Result[Cursor],&U_Sgn_UncnDw1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UncnDw1,4);
  Cursor = Cursor+4;

  //
  //DynamicArray <String>
  // 
  memcpy(&Result[Cursor],&U_Sgn_Items,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 0;
  for (i = 0; i < Items->Length; i++)
  {
    ChetireBaita = ChetireBaita + Items->operator[](i).Length() + 8;
  };
  ChetireBaita = ChetireBaita + 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //   ...
  ChetireBaita = Items->Length;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  // ...
  for (i = 0; i < Items->Length; i++)
  {
    // 
    memcpy(&Result[Cursor],&U_Sgn_Items,4);
    Cursor = Cursor+4;
    // ...
    ChetireBaita = 8+Items->operator[](i).Length();
    memcpy(&Result[Cursor],&ChetireBaita,4);
    Cursor = Cursor+4;
    //...
    if (Items->operator[](i).Length() > 0)
    {
      memcpy(&Result[Cursor],&Items->operator[](i)[1],Items->operator[](i).Length());
      Cursor = Cursor+Items->operator[](i).Length();
    };  
  };

  //" "
  //byte *
  //   -       :).
  memcpy(&Result[Cursor],&TableData[0],TableDataSize);
  Cursor = Cursor+TableDataSize;

  //    ...
  TObjectObjBlock::GenBasePart(&Result[Cursor]);
  Cursor = Cursor+TObjectObjBlock::GetBlockSize()-8;

  // .
  //DynamicArray <BehaviourDataBlock>

  for (i = 0; i < BehaviourDatas->Length; i++)
  {  
    memcpy(&Result[Cursor],&BehaviourDatas->operator [](i).BehaviourData[0],BehaviourDatas->operator [](i).BehaviourDataSize);
    Cursor = Cursor+BehaviourDatas->operator [](i).BehaviourDataSize;
  };

  //  ...
  return Result;
};
